var KEY = {
  UP: 38,
  DOWN: 40,
  W: 87,
  S: 83
}

var pingpong = {}
pingpong.pressedKeys = [];
pingpong.ball = {
  speed: 5,
  x: 150,
  y: 100,
  directionX: 1,
  directionY: 1
}
$(function(){
  // установка интервала, через который вызывается игровой цикл 30 миллисекунд
  pingpong.timer = setInterval(gameloop,30);
  
  // отметим в массиве "pressedKeys", нажата или отпущена клавиша  
  $(document).keydown(function(e){
    pingpong.pressedKeys[e.which] = true;
    });
    $(document).keyup(function(e){
      pingpong.pressedKeys[e.which] = false;
  });
});
function gameloop() {
  movePaddles();
  function gameloop() {
  moveBall();
  movePaddles();
}
function moveBall() {
  // ссылка на переменные
  var playgroundHeight = parseInt($("#playground").height());
  var playgroundWidth = parseInt($("#playground").width());  
  var ball = pingpong.ball;
  
  // проверяем позицию мяча по отношению к границам поля
  // проверяем нижнюю границу
   if (ball.y + ball.speed*ball.directionY > playgroundHeight)
  {
    ball.directionY = -1;
  }
  // проверяем верхнюю границу
  if (ball.y + ball.speed*ball.directionY < 0)
  {
    ball.directionY = 1;
  }
  // проверяем правую границу
  if (ball.x + ball.speed*ball.directionX > playgroundWidth)
  {
    ball.directionX = -1;
  }
  // проверяем левую границу
  if (ball.x + ball.speed*ball.directionX < 0)
  {
    ball.directionX = 1;
  }
  ball.x += ball.speed * ball.directionX;
  ball.y += ball.speed * ball.directionY;
  
  // потом здесь мы будем проверять перемещение дощечек.
  // перемещаем шар с помощью скорости и направления
  $("#ball").css({
    "left" : ball.x,
    "top" : ball.y
  });
}
}
function movePaddles() {
  // используем наш таймер, чтобы проверить, нажата или нет клавиша. 
  if (pingpong.pressedKeys[KEY.UP]) { // клавиша "вверх"
    // перемещаем дощечку paddle B вверх на 5 пикселей
    var top = parseInt($("#paddleB").css("top"));
    $("#paddleB").css("top",top-5);  
  }
  if (pingpong.pressedKeys[KEY.DOWN]) { // клавиша "вниз"
    // перемещаем дощечку B вниз на 5 пикселей
    var top = parseInt($("#paddleB").css("top"));
    $("#paddleB").css("top",top+5);
  }
  if (pingpong.pressedKeys[KEY.W]) { // w
    // перемещаем дощечку paddle A вверх на 5 пикселей
    var top = parseInt($("#paddleA").css("top"));
    $("#paddleA").css("top",top-5);
  }
  if (pingpong.pressedKeys[KEY.S]) { // s
    // перемещаем дощечку A вниз на 5 пикселей
    var top = parseInt($("#paddleA").css("top"));
    $("#paddleA").css("top",top+5);      
  }
}

